#property indicator_chart_window
#property indicator_buffers 0
#property strict

extern string  UniqueID     = "SymbolChanger1";  // Indicator unique ID
extern int     ButtonsInARow = 5;                // Buttons in a horizontal row
extern int     XShift       = 20;                // Horizontal shift
extern int     YShift       = 20;                // Vertical shift
extern color   Bcolor       = clrSilver;         // Button color
extern color   Dcolor       = clrBlack;          // Button border color
extern color   Tncolor      = clrBlack;          // Text color - normal
extern color   Sncolor      = clrRed;            // Text color - selected


//-----------------------------------------------------------------------------------
//
//-----------------------------------------------------------------------------------
//
//
//
//
//
//

int OnInit() 
{
   int xpos=0,ypos=0; 
      for (int i = 0; i<SymbolsTotal(true); i++)
      {
         if (i>0 && MathMod(i,ButtonsInARow)==0) { xpos=0; ypos+=22; } createButton(UniqueID+":"+string(i),SymbolName(i,true),XShift+xpos,YShift+ypos); xpos +=67; 
      }                     
      setButtonColor();
   return(0);   
}
void OnDeinit(const int reason)
{ 
   switch(reason)
   {
      case REASON_PARAMETERS  :
      case REASON_CHARTCHANGE :
      case REASON_RECOMPILE   :
      case REASON_CLOSE       : break;
      default :
      {
         string lookFor       = UniqueID+":";
         int    lookForLength = StringLen(lookFor);
         for (int i=ObjectsTotal()-1; i>=0; i--)
         {
               string objectName = ObjectName(i);  if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
         }
      }                  
   }
}

//
//
//
//
//
//

void createButton(string name, string caption, int xpos, int ypos)
{
   if (ObjectFind(name)!=0)
       ObjectCreate(name,OBJ_BUTTON,0,0,0);
          ObjectSet(name,OBJPROP_CORNER   ,0);
          ObjectSet(name,OBJPROP_XDISTANCE,xpos);
          ObjectSet(name,OBJPROP_YDISTANCE,ypos);
          ObjectSet(name,OBJPROP_XSIZE,65);
          ObjectSet(name,OBJPROP_YSIZE,20);
          ObjectSetText(name,caption,9,"Arial",Tncolor);
              ObjectSet(name,OBJPROP_BORDER_TYPE,BORDER_FLAT);
              ObjectSet(name,OBJPROP_COLOR,Tncolor); 
              ObjectSet(name,OBJPROP_BGCOLOR,Bcolor); 
              ObjectSet(name,OBJPROP_BORDER_COLOR,Dcolor); 
              ObjectSet(name,OBJPROP_STATE,false);
              ObjectSet(name,OBJPROP_HIDDEN,true);
}

void setButtonColor()
{
   string lookFor       = UniqueID+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);  
      if (StringSubstr(objectName,0,lookForLength) == lookFor)
      {
         string symbol = ObjectGetString(0,objectName,OBJPROP_TEXT);
         if (symbol != _Symbol)
               ObjectSet(objectName,OBJPROP_COLOR,Tncolor); 
         else  ObjectSet(objectName,OBJPROP_COLOR,Sncolor);
      }         
   }
}

void OnChartEvent(const int id, const long& lparam, const double& dparam, const string& sparam)
{
   if (id==CHARTEVENT_OBJECT_CLICK && ObjectGet(sparam,OBJPROP_TYPE)==OBJ_BUTTON)
   {
      string symbol = ObjectGetString(0,sparam,OBJPROP_TEXT);
         ChartSetSymbolPeriod(0,symbol,_Period);
         ObjectSetInteger(0,sparam,OBJPROP_STATE,false);
   }
}  

//
//
//
//
//

int start() { return(0); }